﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace Praktikum_1
{
    public partial class MainWindow : Window
    {
        const int zahlDerZeilen = 20;
        const int zahlDerSpalten = 30;
        Button[,] zellen = new Button[zahlDerZeilen, zahlDerSpalten];
        bool[,] zelleLebt = new bool[zahlDerZeilen, zahlDerSpalten];

        public MainWindow()
        {
            InitializeComponent();

            for (int i = 0; i < zahlDerZeilen; i++)
            {
                RowDefinition rd = new RowDefinition();
                rd.Height = new GridLength(1, GridUnitType.Star);
                meinGrid.RowDefinitions.Add(rd);
            }

            for (int i = 0; i < zahlDerSpalten; i++)
            {
                ColumnDefinition cd = new ColumnDefinition();
                cd.Width = new GridLength(1, GridUnitType.Star);
                meinGrid.ColumnDefinitions.Add(cd);
            }

            for (int i = 0; i < zahlDerZeilen; i++)
            {
                for (int j = 0; j < zahlDerSpalten; j++)
                {
                    Button b = new Button();
                    meinGrid.Children.Add(b);
                    Grid.SetRow(b, i);
                    Grid.SetColumn(b, j);
                    b.MouseEnter += MausÜberButton;
                    zellen[i, j] = b;
                    b.FontSize = 6.0;
                    b.Content = i + " " + j;
                }
            }

            AktualisiereKnöpfe();

            DispatcherTimer timer = new DispatcherTimer(); // benötigt using System.Windows.Threading;
            timer.Interval = TimeSpan.FromSeconds(0.1);
            timer.Tick += Animiere;
            timer.Start();
        }

        void AktualisiereKnöpfe()
        {
            for (int i = 0; i < zahlDerZeilen; i++)
            {
                for (int j = 0; j < zahlDerSpalten; j++)
                {
                    Button b = zellen[i, j];
                    if (zelleLebt[i, j])
                    {
                        b.Background = Brushes.Yellow;
                    }
                    else
                    {
                        b.Background = Brushes.LightBlue;
                    }
                }
            }
        }

        void MausÜberButton(object sender, MouseEventArgs e)
        {
            for (int i = 0; i < zahlDerZeilen; i++)
            {
                for (int j = 0; j < zahlDerSpalten; j++)
                {
                    if (zellen[i, j] == sender)
                    {
                        zelleLebt[i, j] = !zelleLebt[i, j];
                        break;
                    }
                }
            }

            AktualisiereKnöpfe();
        }

        void Animiere(object sender, EventArgs e)
        {
            int[,] zahlDerNachbarn = new int[zahlDerZeilen, zahlDerSpalten];

            for (int i = 0; i < zahlDerZeilen; i++)
            {
                int zeileDarüber = i - 1;
                int zeileDarunter = i + 1;
                if(i == 0)
                {
                    zeileDarüber = zahlDerZeilen - 1;
                }
                else if(i == zahlDerZeilen - 1)
                {
                    zeileDarunter = 0;
                }

                for (int j = 0; j < zahlDerSpalten; j++)
                {
                    int spalteLinksDavon = j - 1;
                    int spalteRechtsDavon = j + 1;
                    if (j == 0)
                    {
                        spalteLinksDavon = zahlDerSpalten - 1;
                    }
                    else if (j == zahlDerSpalten - 1)
                    {
                        spalteRechtsDavon = 0;
                    }

                    int z = 0;
                    if (zelleLebt[zeileDarüber, spalteLinksDavon]) { z++; }
                    if (zelleLebt[zeileDarüber, j]) { z++; }
                    if (zelleLebt[zeileDarüber, spalteRechtsDavon]) { z++; }
                    if (zelleLebt[i, spalteLinksDavon]) { z++; }
                    if (zelleLebt[i, spalteRechtsDavon]) { z++; }
                    if (zelleLebt[zeileDarunter, spalteLinksDavon]) { z++; }
                    if (zelleLebt[zeileDarunter, j]) { z++; }
                    if (zelleLebt[zeileDarunter, spalteRechtsDavon]) { z++; }
                    zahlDerNachbarn[i, j] = z;
                }
            }

            for (int i = 0; i < zahlDerZeilen; i++)
            {
                for (int j = 0; j < zahlDerSpalten; j++)
                {
                    if (zelleLebt[i, j])
                    {
                        if(zahlDerNachbarn[i, j] < 2 || zahlDerNachbarn[i, j] > 3)
                        {
                            zelleLebt[i, j] = false;
                        }
                    }
                    else
                    {
                        if(zahlDerNachbarn[i, j] == 3)
                        {
                            zelleLebt[i, j] = true;
                        }
                    }
                }
            }

            AktualisiereKnöpfe();
        }
    }
}
